/**
 * contains specilized meathods to get data out of Glossary_item and format them for display.
 * Creation date: (02/26/00 16:07:05)
 * @author:  Erik Ordway
 The Presentation Manager

The NetLab Project of The Evergreen State College
		  
Java code 
Copyright   2000 by Erik Ordway crainm@techie.com

Non Module specific html, css, and graphics
Copyright   2000 by Brook Hatch

Module specific html, css, and graphics
Copyright   2000 by the Authors of the module

Welcome to The Presentation Manager. This document covers is the licences of The Presentation Manager Release 4.0.
This program and its accompaning modules are a work in progress and are the work of many individuals. If you are 
interested in helping with this project, please contact the NetLab project at http://grace.evergreen.edu/nsl. 
The latest version of this program is always available from the NetLab Wide Web server. It may also 
be downloaded in a variety of formats and compression options from the NetLab web server or run from that site.

Redistribution and use in source java code, html, css, and graphics  and 'compiled' forms java bytecode with or
 without modification, are permitted provided that the following conditions are met:

Redistributions of source code java source code must retain the above copyright notice, this list of conditions 
and the following disclaimer as the first lines of this file unmodified.

Redistributions in compiled form java bytecode with accompaning modules and support html, css, and graphincs  
must reproduce the above copyright notice, this list of conditions and the following disclaimer in the 
documentation and/or other materials provided with the distribution.

Important: THIS PROGRAM AND ITS ACCOMPANING MODULES ARE PROVIDED BY THE NETLAB PROJECT AND ITS AUTHORS "AS IS" 
AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY 
AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE NETLAB PROJECT BE LIABLE FOR ANY 
DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, 
PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER 
CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR 
OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS DOCUMENTATION, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH 
DAMAGE.
 * 
 */
import java.util.*;
import javax.swing.text.*;
import javax.swing.text.html.*;
import java.net.*;
//import com.sun.java.swing.text.html.HTML;
import com.sun.java.swing.text.html.*;

class Glossary_db extends Generic_db
{
	private DefaultStyledDocument doc = new DefaultStyledDocument();
/**
 * Glossary_db constructor comment.
 */
public Glossary_db() {
	super();
}
/**
 * Insert the method's description here.
 * Creation date: (03/14/00 02:13:06)
 * @return java.lang.String
 */
public java.lang.String getHtmlString() {
	return htmlString;
}
/**
 * Insert the method's description here.
 * Creation date: (03/22/00 18:48:32)
 */
public String makeResultHtmlString(Vector result)
{
	//System.out.println("creating html for display in makeHtmlResultString()");
	String lineString;
	
	StringBuffer lineSBuffer = new StringBuffer();
	//lineString = new String("<html><head>");
	//lineSBuffer.append("<html><head>");
	
	//lineString = new String("<title>The Glossary</title> </head>");
	//lineSBuffer.append("<title>The Glossary</title> </head>");
	
	//lineString = new String("<body>");
	//lineSBuffer.append("<body>");
	lineSBuffer.append(getHtmlHead());
	
	Enumeration gItems = result.elements();
	while (gItems.hasMoreElements())
	{
		//System.out.println("there are elements");
		Glossary_item gItem = (Glossary_item) gItems.nextElement();
		lineSBuffer.append(gItem.getHTMLStringB(true));
	}
	
	//lineString = new String("</body></html>");
	//lineSBuffer.append("</body></html>");
	lineSBuffer.append(getHtmlTail());
	
	return new String(lineSBuffer);
}
/**
 * Insert the method's description here.
 * Creation date: (03/22/00 18:48:32)
 */
public String makeSortedHtmlString()
{
	boolean truth = true;
	if (htmlString == null)
	{ //uses the parents class method sotrToTree() to create a new vector that is a vector
		//of vectors containing item with the same name
		this.sortToTree();
		//System.out.println("creating html for display in makeSortedHtmlString()");
		String lineString;
		StringBuffer lineSBuffer = new StringBuffer();
		
		//lineString = new String("<html><head>");
		//lineSBuffer.append(lineString);
		//lineString = new String("<title>The Glossary</title> </head>");
		//lineSBuffer.append(lineString);
		//lineString = new String("<body>");
		//lineSBuffer.append(lineString);
		
		lineSBuffer.append(getHtmlHead());
		
		Enumeration sorted = sorted_item_vector.elements();
		while (sorted.hasMoreElements())
		{
			truth = true;
			Enumeration gItems = ((Vector) sorted.nextElement()).elements();
			while (gItems.hasMoreElements())
			{
				Glossary_item gItem = (Glossary_item) gItems.nextElement();
				//catches it this is the first item in the Vector and adds the word heading
				if (truth)
				{
					lineSBuffer.append("<p><font size=\"5\">");
					lineSBuffer.append(gItem.getWord());
					lineSBuffer.append("</font></p>");
				}
				truth = false;
				lineSBuffer.append(gItem.getHTMLStringB(false));
			}
		}
		//lineString = new String("</body></html>");
		//lineSBuffer.append(lineString);
		
		lineSBuffer.append(getHtmlTail());
		
		htmlString = new String(lineSBuffer);
		//System.out.println(htmlString);
		return htmlString;
	}
	else
	{
		return htmlString;
	}
}
}
