/**
 * Insert the type's description here.
 * Creation date: (02/27/00 12:30:41)
 * @author:  Erik Ordway
 The Presentation Manager

The NetLab Project of The Evergreen State College
		  
Java code 
Copyright   2000 by Erik Ordway crainm@techie.com

Non Module specific html, css, and graphics
Copyright   2000 by Brook Hatch

Module specific html, css, and graphics
Copyright   2000 by the Authors of the module

Welcome to The Presentation Manager. This document covers is the licences of The Presentation Manager Release 4.0.
This program and its accompaning modules are a work in progress and are the work of many individuals. If you are 
interested in helping with this project, please contact the NetLab project at http://grace.evergreen.edu/nsl. 
The latest version of this program is always available from the NetLab Wide Web server. It may also 
be downloaded in a variety of formats and compression options from the NetLab web server or run from that site.

Redistribution and use in source java code, html, css, and graphics  and 'compiled' forms java bytecode with or
 without modification, are permitted provided that the following conditions are met:

Redistributions of source code java source code must retain the above copyright notice, this list of conditions 
and the following disclaimer as the first lines of this file unmodified.

Redistributions in compiled form java bytecode with accompaning modules and support html, css, and graphincs  
must reproduce the above copyright notice, this list of conditions and the following disclaimer in the 
documentation and/or other materials provided with the distribution.

Important: THIS PROGRAM AND ITS ACCOMPANING MODULES ARE PROVIDED BY THE NETLAB PROJECT AND ITS AUTHORS "AS IS" 
AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY 
AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE NETLAB PROJECT BE LIABLE FOR ANY 
DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, 
PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER 
CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR 
OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS DOCUMENTATION, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH 
DAMAGE.
 */
class Glossary_item extends Generic_item{
	public java.lang.String gwordDef;
	private java.net.URL link;
	private int location;
	
/**
 * Gloossary_item constructor comment.
 */
public Glossary_item() {
	super();
}
/**
 * Gloossary_item constructor comment.
 */
public Glossary_item(String newGword , String newModName , String newGwordDef , java.net.URL url) {
	super();
	setWord(newGword);
	setModName(newModName);
	setGwordDef(newGwordDef);
	setLink(url);
}
/**
 * Insert the method's description here.
 * Creation date: (02/27/00 12:33:04)
 * @return java.lang.String
 */
public java.lang.String getGwordDef() {
	return gwordDef;
}
/**
 * Insert the method's description here.
 * Creation date: (03/22/00 20:00:38)
 * @return java.lang.String
 */
public StringBuffer getHTMLStringB(boolean needWord)
{//the boolean needWord is used to tell if the Glossary word needs to be sent back or not
	StringBuffer lineSBuffer = new StringBuffer();
	if (needWord){
	//the defining word
	lineSBuffer.append("<p><font size=\"5\">");
	lineSBuffer.append(this.getWord());
	lineSBuffer.append("</font></p>");
	//System.out.println(this.getWord());
	//System.out.println(lineString);
	}
	//
	//ling to the module main page
	lineSBuffer.append("<p><a href=\"");
	lineSBuffer.append(this.getLink().toString());
	lineSBuffer.append("\" target =\"main\">");
	lineSBuffer.append(this.getModName());
	lineSBuffer.append("</a></p>");
	//System.out.println(this.getModName());
	//System.out.println(lineString);
	
	//
	//the definitions
	lineSBuffer.append("<p>");
	lineSBuffer.append(this.getGwordDef());
	lineSBuffer.append("</p>");
	//System.out.println(this.getGwordDef());
	//System.out.println(lineString);
	
	return lineSBuffer;
}
/**
 * Insert the method's description here.
 * Creation date: (03/14/00 02:16:51)
 * @return int
 */
public int getLocation() {
	return location;
}
/**
 * Insert the method's description here.
 * Creation date: (02/27/00 12:33:04)
 * @return java.lang.String
 */
public java.lang.String getwordDef() {
	return gwordDef;
}
/**
 * Insert the method's description here.
 * Creation date: (02/27/00 12:33:04)
 * @param newGwordDef java.lang.String
 */
private void setGwordDef(java.lang.String newGwordDef) {
	gwordDef = newGwordDef;
}
/**
 * Insert the method's description here.
 * Creation date: (03/14/00 02:16:51)
 * @param newLocation int
 */
public void setLocation(int newLocation) {
	location = newLocation;
}
}
