/**
 * Insert the type's description here.
 * Creation date: (02/27/00 12:37:50)
 * @author:  Erik Ordway
 The Presentation Manager

The NetLab Project of The Evergreen State College
		  
Java code 
Copyright   2000 by Erik Ordway crainm@techie.com

Non Module specific html, css, and graphics
Copyright   2000 by Brook Hatch

Module specific html, css, and graphics
Copyright   2000 by the Authors of the module

Welcome to The Presentation Manager. This document covers is the licences of The Presentation Manager Release 4.0.
This program and its accompaning modules are a work in progress and are the work of many individuals. If you are 
interested in helping with this project, please contact the NetLab project at http://grace.evergreen.edu/nsl. 
The latest version of this program is always available from the NetLab Wide Web server. It may also 
be downloaded in a variety of formats and compression options from the NetLab web server or run from that site.

Redistribution and use in source java code, html, css, and graphics  and 'compiled' forms java bytecode with or
 without modification, are permitted provided that the following conditions are met:

Redistributions of source code java source code must retain the above copyright notice, this list of conditions 
and the following disclaimer as the first lines of this file unmodified.

Redistributions in compiled form java bytecode with accompaning modules and support html, css, and graphincs  
must reproduce the above copyright notice, this list of conditions and the following disclaimer in the 
documentation and/or other materials provided with the distribution.

Important: THIS PROGRAM AND ITS ACCOMPANING MODULES ARE PROVIDED BY THE NETLAB PROJECT AND ITS AUTHORS "AS IS" 
AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY 
AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE NETLAB PROJECT BE LIABLE FOR ANY 
DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, 
PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER 
CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR 
OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS DOCUMENTATION, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH 
DAMAGE.
 */
class Keyword_item extends Generic_item{
	public java.lang.String about;
	public boolean isModLev;
	private java.lang.String htmlFrag;
/**
 * Keyword_item constructor comment.
 */
public Keyword_item() {
	super();
}
/**
 * Gloossary_item constructor 
 * newGword is the searchable value
 * NewModName is name of the module that the GWOrd belongs
 * url is the url of the module
 * 
 */
public Keyword_item(String newGword, String newModName, boolean isModLevel, java.net.URL url)
{
	super();
	setWord(newGword);
	setModName(newModName);
	setIsModLev(isModLevel);
	setLink(url);
	//setHtmlFrag(frag);
}
/**
 * Gloossary_item constructor 
 * newGword is the searchable value
 * NewModName is name of the module that the GWOrd belongs
 * url is the url of the module
 * frag used in creating output to html
 * 
 */
public Keyword_item(String newGword, String newModName, boolean isModLevel, java.net.URL url , String frag)
{
	super();
	setWord(newGword);
	setModName(newModName);
	setIsModLev(isModLevel);
	setLink(url);
	setHtmlFrag(frag);
}
/**
 * Insert the method's description here.
 * Creation date: (02/27/00 12:43:12)
 * @return java.lang.String
 */
public java.lang.String getAbout() {
	return about;
}
/**
 * Insert the method's description here.
 * Creation date: (03/22/00 20:00:38)
 * @return java.lang.String
 */
public String getHTMLString()
{
	StringBuffer lineSBuffer = new StringBuffer();

	return getHtmlFrag();

}
/**
 * Insert the method's description here.
 * Creation date: (04/18/00 16:28:13)
 * @return java.lang.String
 */
public java.lang.String getHtmlFrag() {
	String temp = new String("<p>From the module ");  
	temp = temp.concat(this.getModName() );
	temp = temp.concat("</p>");
	temp = temp.concat(htmlFrag);
	return temp;
}
/**
 * Insert the method's description here.
 * Creation date: (03/04/00 13:29:29)
 * @return java.net.URL
 */
public java.net.URL getLink() {
	return link;
}
/**
 * Insert the method's description here.
 * Creation date: (02/27/00 12:57:51)
 * @return boolean
 */
public boolean isIsModLev() {
	return isModLev;
}
/**
 * Insert the method's description here.
 * Creation date: (02/27/00 12:43:12)
 * @param newAbout java.lang.String
 */
private void setAbout(java.lang.String newAbout) {
	about = newAbout;
}
/**
 * Insert the method's description here.
 * Creation date: (04/18/00 16:28:13)
 * @param newHtmlFrag java.lang.String
 */
private void setHtmlFrag(java.lang.String newHtmlFrag) {
	htmlFrag = newHtmlFrag;
}
/**
 * Insert the method's description here.
 * Creation date: (02/27/00 12:57:51)
 * @param newIsModLev boolean
 */
private void setIsModLev(boolean newIsModLev) {
	isModLev = newIsModLev;
}
/**
 * Insert the method's description here.
 * Creation date: (03/04/00 13:29:29)
 * @param newLink java.net.URL
 */
public void setLink(java.net.URL newLink) {
	link = newLink;
}
}
