/**
 * this is a front end to the presentation manager.  It uses the data provived by a DBWrapper
 * to function.
 * Creation date: (04/01/00 22:17:59)
 * @author: Erik Ordway
The Presentation Manager

The NetLab Project of The Evergreen State College
		  
Java code 
Copyright   2000 by Erik Ordway crainm@techie.com

Non Module specific html, css, and graphics
Copyright   2000 by Brook Hatch

Module specific html, css, and graphics
Copyright   2000 by the Authors of the module

Welcome to The Presentation Manager. This document covers is the licences of The Presentation Manager Release 4.0.
This program and its accompaning modules are a work in progress and are the work of many individuals. If you are 
interested in helping with this project, please contact the NetLab project at http://grace.evergreen.edu/nsl. 
The latest version of this program is always available from the NetLab Wide Web server. It may also 
be downloaded in a variety of formats and compression options from the NetLab web server or run from that site.

Redistribution and use in source java code, html, css, and graphics  and 'compiled' forms java bytecode with or
 without modification, are permitted provided that the following conditions are met:

Redistributions of source code java source code must retain the above copyright notice, this list of conditions 
and the following disclaimer as the first lines of this file unmodified.

Redistributions in compiled form java bytecode with accompaning modules and support html, css, and graphincs  
must reproduce the above copyright notice, this list of conditions and the following disclaimer in the 
documentation and/or other materials provided with the distribution.

Important: THIS PROGRAM AND ITS ACCOMPANING MODULES ARE PROVIDED BY THE NETLAB PROJECT AND ITS AUTHORS "AS IS" 
AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY 
AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE NETLAB PROJECT BE LIABLE FOR ANY 
DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, 
PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER 
CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR 
OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS DOCUMENTATION, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH 
DAMAGE.
 * 
 */

import java.applet.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.net.URL;
import java.net.MalformedURLException;
import javax.swing.*;
import javax.swing.text.html.*;
import javax.swing.SwingUtilities.*;
import javax.swing.event.*;
import javax.swing.text.*;
import java.util.Enumeration;
import java.util.Vector;
import java.lang.String;
import javax.accessibility.*;

public class PMembedable extends javax.swing.JApplet implements KeyListener, MouseListener, MouseMotionListener
{
	private javax.swing.JTabbedPane JTabbedPane1 = null;
	private javax.swing.JComboBox ModSelectCombo = null;
	private javax.swing.JButton SearchButton = null;
	private javax.swing.JTextField SearchText = null;
	private javax.swing.JButton ShowAllButton = null;
	private javax.swing.JPanel JGlossaryPanel2 = null;
	private javax.swing.JPanel JKeywordPanel3 = null;
	private javax.swing.JPanel JModSelectPane1 = null;
	private javax.swing.JEditorPane JAboutEditorPane3 = null;
	private javax.swing.JPanel JAboutPanel2 = null;
	private javax.swing.JScrollPane JAboutScrollPane4 = null;
	private javax.swing.JEditorPane JGlossaryEditorPane = null;
	private javax.swing.JScrollPane JGlossaryScrollPane1 = null;
	private javax.swing.JEditorPane JKeywordEditorPane2 = null;
	private javax.swing.JScrollPane JKeywordScrollPane2 = null;
	private javax.swing.JButton JModLoadButton1 = null;
	private javax.swing.JEditorPane JModSelectEditorPane2 = null;
	private javax.swing.JScrollPane JModSelectScrollPane3 = null;
	private javax.swing.JPanel JPMPanel1 = null;
	EventHandler EventHandler = new EventHandler();
	private javax.swing.JButton JButton1 = null;
	private javax.swing.JDialog JDialog1 = null;
	private javax.swing.JPanel JDialogContentPane = null;
	private javax.swing.JTextPane JLabel1 = null;
	//mine
	private javax.swing.JButton loadButton = null;
	private javax.swing.JFrame PMFrame = null;
	private java.applet.AppletContext context;
	private DBWrapper storage;
	class EventHandler implements javax.swing.event.ChangeListener, java.awt.event.ActionListener
	{
		public void actionPerformed(java.awt.event.ActionEvent e)
		{
			if (e.getSource() == PMembedable.this.getSearchText())
				connEtoC1(e);
			if (e.getSource() == PMembedable.this.getSearchButton())
				connEtoC2(e);
			if (e.getSource() == PMembedable.this.getModSelectCombo())
				connEtoC3(e);
			if (e.getSource() == PMembedable.this.getShowAllButton())
				connEtoC4(e);
			if (e.getSource() == PMembedable.this.getJModLoadButton1())
				connEtoC6(e);
			if (e.getSource() == PMembedable.this.getLoadButton())
				connEtoC7(e);
		};
		public void stateChanged(javax.swing.event.ChangeEvent e)
		{
			if (e.getSource() == PMembedable.this.getJTabbedPane1())
				connEtoC5(e);
		};
	};
/**
 * connEtoC1:  (SearchText.action.actionPerformed(java.awt.event.ActionEvent) --> wideAndShallow.searchText_ActionPerformed(Ljava.awt.event.ActionEvent;)V)
 * @param arg1 java.awt.event.ActionEvent
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private void connEtoC1(java.awt.event.ActionEvent arg1) {
	try {
		// user code begin {1}
		// user code end
		this.searchText_ActionPerformed(arg1);
		// user code begin {2}
		// user code end
	} catch (java.lang.Throwable ivjExc) {
		// user code begin {3}
		// user code end
		handleException(ivjExc);
	}
}
/**
 * connEtoC2:  (SearchButton.action.actionPerformed(java.awt.event.ActionEvent) --> wideAndShallow.searchButton_ActionPerformed(Ljava.awt.event.ActionEvent;)V)
 * @param arg1 java.awt.event.ActionEvent
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private void connEtoC2(java.awt.event.ActionEvent arg1) {
	try {
		// user code begin {1}
		// user code end
		this.searchButton_ActionPerformed(arg1);
		// user code begin {2}
		// user code end
	} catch (java.lang.Throwable ivjExc) {
		// user code begin {3}
		// user code end
		handleException(ivjExc);
	}
}
/**
 * connEtoC3:  (ModSelectCombo.action.actionPerformed(java.awt.event.ActionEvent) --> wideAndShallow.modSelectCombo_ActionPerformed(Ljava.awt.event.ActionEvent;)V)
 * @param arg1 java.awt.event.ActionEvent
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private void connEtoC3(java.awt.event.ActionEvent arg1) {
	try {
		// user code begin {1}
		// user code end
		this.modSelectCombo_ActionPerformed(arg1);
		// user code begin {2}
		// user code end
	} catch (java.lang.Throwable ivjExc) {
		// user code begin {3}
		// user code end
		handleException(ivjExc);
	}
}
/**
 * connEtoC4:  (ShowAllButton.action.actionPerformed(java.awt.event.ActionEvent) --> wideAndShallow.showAllButton_ActionPerformed(Ljava.awt.event.ActionEvent;)V)
 * @param arg1 java.awt.event.ActionEvent
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private void connEtoC4(java.awt.event.ActionEvent arg1) {
	try {
		// user code begin {1}
		// user code end
		this.showAllButton_ActionPerformed(arg1);
		// user code begin {2}
		// user code end
	} catch (java.lang.Throwable ivjExc) {
		// user code begin {3}
		// user code end
		handleException(ivjExc);
	}
}
/**
 * connEtoC5:  (JTabbedPane1.change.stateChanged(com.sun.java.swing.event.ChangeEvent) --> wideAndShallow.jTabbedPane1_StateChanged(Lcom.sun.java.swing.event.ChangeEvent;)V)
 * @param arg1 com.sun.java.swing.event.ChangeEvent
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private void connEtoC5(javax.swing.event.ChangeEvent arg1) {
	try {
		// user code begin {1}
		// user code end
		this.jTabbedPane1_StateChanged(arg1);
		// user code begin {2}
		// user code end
	} catch (java.lang.Throwable ivjExc) {
		// user code begin {3}
		// user code end
		handleException(ivjExc);
	}
}
/**
 * connEtoC6:  (JModLoadButton1.action.actionPerformed(java.awt.event.ActionEvent) --> wideAndShallow.jModLoadButton1_ActionPerformed(Ljava.awt.event.ActionEvent;)V)
 * @param arg1 java.awt.event.ActionEvent
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private void connEtoC6(java.awt.event.ActionEvent arg1) {
	try {
		// user code begin {1}
		// user code end
		this.jModLoadButton1_ActionPerformed(arg1);
		// user code begin {2}
		// user code end
	} catch (java.lang.Throwable ivjExc) {
		// user code begin {3}
		// user code end
		handleException(ivjExc);
	}
}
/**
 * connEtoC6:  (JModLoadButton1.action.actionPerformed(java.awt.event.ActionEvent) --> wideAndShallow.jModLoadButton1_ActionPerformed(Ljava.awt.event.ActionEvent;)V)
 * @param arg1 java.awt.event.ActionEvent
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private void connEtoC7(java.awt.event.ActionEvent arg1) {
	try {
		// user code begin {1}
		// user code end
		//System.out.println("trying to make PMFrame visible");
		this.getPMFrame().setVisible(true);
		// user code begin {2}
		// user code end
	} catch (java.lang.Throwable ivjExc) {
		// user code begin {3}
		// user code end
		handleException(ivjExc);
	}
}
/**
 * Returns information about this applet.
 * @return a string of information about this applet
 */
public String getAppletInfo() {
	return "wideAndShallow\n" + 
		"\n" + 
		"Insert the type's description here.\n" + 
		"Creation date: (04/01/00 22:17:59)\n" + 
		"@author: \n" + 
		"";
}
/**
 * Insert the method's description here.
 * Creation date: (04/05/00 20:58:10)
 * @return java.applet.AppletContext
 */
private java.applet.AppletContext getContext() {
	return context;
}
/**
 * Return the JAboutEditorPane3 property value.
 * @return javax.swing.JEditorPane
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private javax.swing.JEditorPane getJAboutEditorPane3()
{
	if (JAboutEditorPane3 == null)
	{
		try
		{
			JAboutEditorPane3 = new javax.swing.JEditorPane();
			JAboutEditorPane3.setName("JAboutEditorPane3");
			JAboutEditorPane3.setBounds(0, 0, 6, 20);
			JAboutEditorPane3.setEditable(false);
			JAboutEditorPane3.setContentType("text/html");
			// user code begin {1}
			URL url;
			LineNumberReader file;
			String line = new String();
			String about = new String();
			try
			{ //System.out.println(modURLString);
				url = new URL((getCodeBase().toString().concat("aboutpm.htm")));
				try
				{
					file = new LineNumberReader(new InputStreamReader((url.openStream())));
					while (line != null)
					{
						try
						{
							line = file.readLine();
							if (line != null)
							{
								about = about.concat(line);
							}
						}
						catch (IOException e)
						{
							System.out.println("read line failed");
							line = null;
						}
					}
				}
				catch (IOException e)
				{
					System.out.println("The file about.htm  was unavailable for reading:");
				}
			}
			catch (MalformedURLException e)
			{
				System.out.println("URL is malformend");
			}
			
			//modify the url to point to another location
			String codebase = getCodeBase().toString();
			int point  = about.indexOf("aboutpm/content/index.htm");
			//System.out.println(point);
			String test = about.substring(1360,1370);
			//System.out.println(test);
			StringBuffer tempBuffer = new StringBuffer(about);
			tempBuffer.insert(1360,codebase);
			about = tempBuffer.toString();
			
			StringReader sr = new StringReader(about);
			//Document doc = JAboutEditorPane3.getDocument();
			try
			{
				JAboutEditorPane3.read(sr, JAboutEditorPane3.getDocument());
			}
			catch (IOException e)
			{
				context.showStatus("java.io.IOExecption e");
			}
			// user code end
		}
		catch (java.lang.Throwable Exc)
		{
			// user code begin {2}
			// user code end
			handleException(Exc);
		}
	}
	return JAboutEditorPane3;
}
/**
 * Return the JAboutPanel2 property value.
 * @return javax.swing.JPanel
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private javax.swing.JPanel getJAboutPanel2() {
	if ( JAboutPanel2 == null) {
		try {
			 JAboutPanel2 = new javax.swing.JPanel();
			 JAboutPanel2.setName("JAboutPanel2");
			 JAboutPanel2.setLayout(null);
			getJAboutPanel2().add(getJAboutScrollPane4(), getJAboutScrollPane4().getName());
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable  Exc) {
			// user code begin {2}
			// user code end
			handleException( Exc);
		}
	}
	return  JAboutPanel2;
}
/**
 * Return the JAboutScrollPane4 property value.
 * @return javax.swing.JScrollPane
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private javax.swing.JScrollPane getJAboutScrollPane4() {
	if ( JAboutScrollPane4 == null) {
		try {
			 JAboutScrollPane4 = new javax.swing.JScrollPane();
			 JAboutScrollPane4.setName("JAboutScrollPane4");
			 JAboutScrollPane4.setBounds(2, 2, 478, 162);
			  JAboutScrollPane4.setToolTipText("Learn about were to get this software");
			getJAboutScrollPane4().setViewportView(getJAboutEditorPane3());
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable  Exc) {
			// user code begin {2}
			// user code end
			handleException( Exc);
		}
	}
	return  JAboutScrollPane4;
}
/**
 * Return the JButton1 property value.
 * @return javax.swing.JButton
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private javax.swing.JButton getJButton1() {
	if ( JButton1 == null) {
		try {
			 JButton1 = new javax.swing.JButton();
			 
			 JButton1.setName("JButton1");
			 JButton1.setText("JButton1");
			 JButton1.setBounds(22, 89, 181, 26);
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable  Exc) {
			// user code begin {2}
			// user code end
			handleException( Exc);
		}
	}
	return  JButton1;
}
/**
 * Return the JDialog1 property value.
 * @return javax.swing.JDialog
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private javax.swing.JDialog getJDialog1() {
	if ( JDialog1 == null) {
		try {
			 JDialog1 = new javax.swing.JDialog();
			 JDialog1.setName("JDialog1");
			 JDialog1.setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
			 JDialog1.setBounds(143, 350, 225, 124);
			 JDialog1.setTitle("Load Error");
			getJDialog1().setContentPane(getJDialogContentPane());
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable  Exc) {
			// user code begin {2}
			// user code end
			handleException( Exc);
		}
	}
	return  JDialog1;
}
/**
 * Return the JDialogContentPane property value.
 * @return javax.swing.JPanel
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private javax.swing.JPanel getJDialogContentPane() {
	if ( JDialogContentPane == null) {
		try {
			 JDialogContentPane = new javax.swing.JPanel();
			 JDialogContentPane.setName("JDialogContentPane");
			 JDialogContentPane.setLayout(null);
			getJDialogContentPane().add(getJLabel1(), getJLabel1().getName());
			getJDialogContentPane().add(getJButton1(), getJButton1().getName());
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable  Exc) {
			// user code begin {2}
			// user code end
			handleException( Exc);
		}
	}
	return  JDialogContentPane;
}
/**
 * Return the JGlossaryEditorPane1 property value.
 * @return javax.swing.JEditorPane
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private javax.swing.JEditorPane getJGlossaryEditorPane() {
	if ( JGlossaryEditorPane == null) {
		try {
			 JGlossaryEditorPane = new javax.swing.JEditorPane();
			 JGlossaryEditorPane.setName("JGlossaryEditorPane1");
			 JGlossaryEditorPane.setBounds(0, 0, 6, 20);
			 JGlossaryEditorPane.setEditable(false);
			 JGlossaryEditorPane.setContentType("text/html");
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable  Exc) {
			// user code begin {2}
			// user code end
			handleException( Exc);
		}
	}
	return  JGlossaryEditorPane;
}
/**
 * Return the JGlossaryPanel2 property value.
 * @return javax.swing.JPanel
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private javax.swing.JPanel getJGlossaryPanel2() {
	if ( JGlossaryPanel2 == null) {
		try {
			 JGlossaryPanel2 = new javax.swing.JPanel();
			 JGlossaryPanel2.setName("JGlossaryPanel2");
			 JGlossaryPanel2.setLayout(null);
			getJGlossaryPanel2().add(getJGlossaryScrollPane1(), getJGlossaryScrollPane1().getName());
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable  Exc) {
			// user code begin {2}
			// user code end
			handleException( Exc);
		}
	}
	return  JGlossaryPanel2;
}
/**
 * Return the JGlossaryScrollPane1 property value.
 * @return javax.swing.JScrollPane
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private javax.swing.JScrollPane getJGlossaryScrollPane1() {
	if ( JGlossaryScrollPane1 == null) {
		try {
			 JGlossaryScrollPane1 = new javax.swing.JScrollPane();
			 JGlossaryScrollPane1.setName("JGlossaryScrollPane1");
			 JGlossaryScrollPane1.setBounds(2, 2, 478, 162);
			getJGlossaryScrollPane1().setViewportView(getJGlossaryEditorPane());
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable  Exc) {
			// user code begin {2}
			// user code end
			handleException( Exc);
		} 
	}
	return  JGlossaryScrollPane1;
}
/**
 * Return the JKeywordEditorPane2 property value.
 * @return javax.swing.JEditorPane
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private javax.swing.JEditorPane getJKeywordEditorPane2() {
	if ( JKeywordEditorPane2 == null) {
		try {
			 JKeywordEditorPane2 = new javax.swing.JEditorPane();
			 JKeywordEditorPane2.setName("JKeywordEditorPane2");
			 JKeywordEditorPane2.setBounds(0, 0, 6, 20);
			 JKeywordEditorPane2.setEditable(false);
			 JKeywordEditorPane2.setContentType("text/html");
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable  Exc) {
			// user code begin {2}
			// user code end
			handleException( Exc);
		}
	}
	return  JKeywordEditorPane2;
}
/**
 * Return the JKeywordPanel3 property value.
 * @return javax.swing.JPanel
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private javax.swing.JPanel getJKeywordPanel3() {
	if ( JKeywordPanel3 == null) {
		try {
			 JKeywordPanel3 = new javax.swing.JPanel();
			 JKeywordPanel3.setName("JKeywordPanel3");
			 JKeywordPanel3.setLayout(null);
			getJKeywordPanel3().add(getJKeywordScrollPane2(), getJKeywordScrollPane2().getName());
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable  Exc) {
			// user code begin {2}
			// user code end
			handleException( Exc);
		}
	}
	return  JKeywordPanel3;
}
/**
 * Return the JKeywordScrollPane2 property value.
 * @return javax.swing.JScrollPane
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private javax.swing.JScrollPane getJKeywordScrollPane2() {
	if ( JKeywordScrollPane2 == null) {
		try {
			 JKeywordScrollPane2 = new javax.swing.JScrollPane();
			 JKeywordScrollPane2.setName("JKeywordScrollPane2");
			 JKeywordScrollPane2.setBounds(2, 2, 478, 162);
			getJKeywordScrollPane2().setViewportView(getJKeywordEditorPane2());
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable  Exc) {
			// user code begin {2}
			// user code end
			handleException( Exc);
		}
	}
	return  JKeywordScrollPane2;
}
/**
 * Return the JLabel1 property value.
 * @return javax.swing.JTextPane
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private javax.swing.JTextPane getJLabel1() {
	if ( JLabel1 == null) {
		try {
			 JLabel1 = new javax.swing.JTextPane();
			 JLabel1.setName("JLabel1");
			 JLabel1.setText("I\'m Sorry due to a content error we are unable to display the content you requested.");
			 JLabel1.setBounds(22, 15, 181, 67);
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable  Exc) {
			// user code begin {2}
			// user code end
			handleException( Exc);
		}
	}
	return  JLabel1;
}
/**
 * Return the JButton1 property value.
 * @return javax.swing.JButton
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private javax.swing.JButton getJModLoadButton1() {
	if ( JModLoadButton1 == null) {
		try {
			 JModLoadButton1 = new javax.swing.JButton();
			 JModLoadButton1.setName("JModLoadButton1");
			 JModLoadButton1.setIcon(new javax.swing.ImageIcon(getClass().getResource("/ModBut.gif")));
			 JModLoadButton1.setText("");
			 JModLoadButton1.setBounds(2, 2, 30, 162);
			 JModLoadButton1.setActionCommand("");
			 JModLoadButton1.setToolTipText("Load this module in the broswer");
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable  Exc) {
			// user code begin {2}
			// user code end
			handleException( Exc);
		}
	}
	return  JModLoadButton1;
}
/**
 * Return the JModSelectEditorPane2 property value.
 * @return javax.swing.JEditorPane
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private javax.swing.JEditorPane getJModSelectEditorPane2() {
	if ( JModSelectEditorPane2 == null) {
		try {
			 JModSelectEditorPane2 = new javax.swing.JEditorPane();
			 JModSelectEditorPane2.setName("JModSelectEditorPane2");
			 JModSelectEditorPane2.setBounds(0, 0, 6, 20);
			 JModSelectEditorPane2.setEditable(false);
			 JModSelectEditorPane2.setContentType("text/html");
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable  Exc) {
			// user code begin {2}
			// user code end
			handleException( Exc);
		}
	}
	return  JModSelectEditorPane2;
}
/**
 * Return the Page property value.
 * @return javax.swing.JPanel
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private javax.swing.JPanel getJModSelectPane1() {
	if ( JModSelectPane1 == null) {
		try {
			 JModSelectPane1 = new javax.swing.JPanel();
			 JModSelectPane1.setName("JModSelectPane1");
			 JModSelectPane1.setLayout(null);
			getJModSelectPane1().add(getJModLoadButton1(), getJModLoadButton1().getName());
			getJModSelectPane1().add(getJModSelectScrollPane3(), getJModSelectScrollPane3().getName());
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable  Exc) {
			// user code begin {2}
			// user code end
			handleException( Exc);
		}
	}
	return  JModSelectPane1;
}
/**
 * Return the JScrollPane3 property value.
 * @return javax.swing.JScrollPane
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private javax.swing.JScrollPane getJModSelectScrollPane3() {
	if ( JModSelectScrollPane3 == null) {
		try {
			 JModSelectScrollPane3 = new javax.swing.JScrollPane();
			 JModSelectScrollPane3.setName("JModSelectScrollPane3");
			 JModSelectScrollPane3.setBounds(34, 2, 445, 162);
			getJModSelectScrollPane3().setViewportView(getJModSelectEditorPane2());
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable  Exc) {
			// user code begin {2}
			// user code end
			handleException( Exc);
		}
	}
	return  JModSelectScrollPane3;
}
/**
 * Return the JPanel1 property value.
 * @return javax.swing.JPanel
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private javax.swing.JPanel getJPMPanel1() {
	if ( JPMPanel1 == null) {
		try {
			 JPMPanel1 = new javax.swing.JPanel();
			 JPMPanel1.setName("JPMPanel1");
			 JPMPanel1.setLayout(null);
			getJPMPanel1().add(getSearchText(), getSearchText().getName());
			getJPMPanel1().add(getSearchButton(), getSearchButton().getName());
			getJPMPanel1().add(getShowAllButton(), getShowAllButton().getName());
			getJPMPanel1().add(getModSelectCombo(), getModSelectCombo().getName());
			getJPMPanel1().add(getJTabbedPane1(), getJTabbedPane1().getName());
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable  Exc) {
			// user code begin {2}
			// user code end
			handleException( Exc);
		}
	}
	return  JPMPanel1;
}
/**
 * Return the JTabbedPane1 property value.
 * @return javax.swing.JTabbedPane
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private javax.swing.JTabbedPane getJTabbedPane1() {
	if ( JTabbedPane1 == null) {
		try {
			 JTabbedPane1 = new javax.swing.JTabbedPane();
			 JTabbedPane1.setName("JTabbedPane1");
			 JTabbedPane1.setTabPlacement(javax.swing.JTabbedPane.LEFT);
			 JTabbedPane1.setBounds(2, 29, 595, 169);
			 JTabbedPane1.insertTab("Module Select", null, getJModSelectPane1(), null, 0);
			 JTabbedPane1.insertTab("Glossary", null, getJGlossaryPanel2(), null, 1);
			 JTabbedPane1.insertTab("Keywords", null, getJKeywordPanel3(), null, 2);
			 JTabbedPane1.insertTab("About Box", null, getJAboutPanel2(), null, 3);
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable  Exc) {
			// user code begin {2}
			// user code end
			handleException( Exc);
		}
	}
	return  JTabbedPane1;
}
/**
 * Return the JButton1 property value.
 * @return javax.swing.JButton
 * eused to create the button that displays the PM
 */
private javax.swing.JButton getLoadButton()
{
	if (loadButton == null)
	{
		try
		{
			loadButton = new javax.swing.JButton();
			loadButton.setName("loadButton");
			loadButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/nettie1.gif")));
			loadButton.setText("");
			loadButton.setBounds(0, 0, 75, 75);
			// user code begin {1}
			// user code end
		}
		catch (java.lang.Throwable Exc)
		{
			// user code begin {2}
			// user code end
			handleException(Exc);
		}
	}
	return loadButton;
}
/**
 * Return the JComboBox1 property value.
 * @return javax.swing.JComboBox
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private javax.swing.JComboBox getModSelectCombo() {
	if ( ModSelectCombo == null) {
		try {
			 ModSelectCombo = new javax.swing.JComboBox();
			 ModSelectCombo.setName("ModSelectCombo");
			 ModSelectCombo.setToolTipText("Select the Module you are interested in.");
			 ModSelectCombo.setBounds(302, 1, 147, 27);
			 ModSelectCombo.setToolTipText("Select which module to learn about.");
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable  Exc) {
			// user code begin {2}
			// user code end
			handleException( Exc);
		}
	}
	return  ModSelectCombo;
}
/**
 * Return the JFrame1 property value.
 * @return com.sun.java.swing.JFrame
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private javax.swing.JFrame getPMFrame() {
	if (PMFrame == null) {
		try {
			PMFrame = new javax.swing.JFrame();
			PMFrame.setName("PMFrame");
			PMFrame.setDefaultCloseOperation(javax.swing.WindowConstants.HIDE_ON_CLOSE);
			PMFrame.setBounds(1, 10, 600, 240);
			getPMFrame().setContentPane(getJPMPanel1());
			PMFrame.setVisible(false);
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable Exc) {
			// user code begin {2}
			// user code end
			handleException(Exc);
		}
	}
	return PMFrame;
}
/**
 * Return the JButton1 property value.
 * @return javax.swing.JButton
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private javax.swing.JButton getSearchButton() {
	if ( SearchButton == null) {
		try {
			 SearchButton = new javax.swing.JButton();
			 SearchButton.setName("SearchButton");
			 SearchButton.setToolTipText("Search for Glossary items or Keywords if in that tab.");
			 SearchButton.setText("Search");
			 SearchButton.setBounds(151, 1, 150, 27);
			 SearchButton.setToolTipText("Search for Glossary items unless you are in the Keywords tab.");
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable  Exc) {
			// user code begin {2}
			// user code end
			handleException( Exc);
		}
	}
	return  SearchButton;
}
/**
 * Return the JTextField1 property value.
 * @return javax.swing.JTextField
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private javax.swing.JTextField getSearchText() {
	if ( SearchText == null) {
		try {
			 SearchText = new javax.swing.JTextField();
			 SearchText.setName("SearchText");
			 SearchText.setToolTipText("Enter text to Seach on here.");
			 SearchText.setBounds(1, 1, 150, 27);
			 SearchText.setToolTipText("Enter text here to search on.");
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable  Exc) {
			// user code begin {2}
			// user code end
			handleException( Exc);
		}
	}
	return  SearchText;
}
/**
 * Return the JButton2 property value.
 * @return javax.swing.JButton
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private javax.swing.JButton getShowAllButton() {
	if ( ShowAllButton == null) {
		try {
			 ShowAllButton = new javax.swing.JButton();
			 ShowAllButton.setName("ShowAllButton");
			 ShowAllButton.setToolTipText("Show all entries in the Glossary or Keywords list.");
			 ShowAllButton.setText("Show all Items");
			 ShowAllButton.setBounds(449, 1, 150, 27);
			 ShowAllButton.setToolTipText("Show all Glossary items unless you are in the Keywords tab");
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable  Exc) {
			// user code begin {2}
			// user code end
			handleException( Exc);
		}
	}
	return  ShowAllButton;
}
/**
 * Called whenever the part throws an exception.
 * @param exception java.lang.Throwable
 */
private void handleException(java.lang.Throwable exception) {

	/* Uncomment the following lines to print uncaught exceptions to stdout */
	 System.out.println("--------- UNCAUGHT EXCEPTION ---------");
	 exception.printStackTrace(System.out);
}
/**
 * Initializes the applet.
 */
public void init()
{
	try
	{
		setName("pm");
		setSize(75, 75);
		setContentPane(getLoadButton());
		//setContentPane(getJPMPanel1());
		PMFrame = getPMFrame();
		initConnections();
		// user code begin {1}
		JRootPane rp = PMembedable.this.getRootPane();
		rp.putClientProperty("defeatSystemEventQueueCheck", Boolean.TRUE);

		//Setting context with the applets browser context
		setContext(getAppletContext());
		//need code to come up with the URL for load(Modules|Glossary|Keyword)
		//can I get it from the browser when it runs the applet
		URL codebase = getCodeBase();

		//create instance of DBWrapper to incase all data storage
		//this creates and loads all of the data storage used by the PM
		storage = new DBWrapper(getContext(), codebase);

		//System.out.println("init()");
		loadModCombo();
	}
	catch (java.lang.Throwable ivjExc)
	{
		// user code begin {2}
		// user code end
		handleException(ivjExc);
	}
}
/**
 * Initializes connections
 * @exception java.lang.Exception The exception description.
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private void initConnections() throws java.lang.Exception
{
	// user code begin {1}
	//THe HyperLinkListenters need to be rewriten to cause the browser to load the page
	//HyperlinkListener for ModInfo

	JModSelectEditorPane2.addHyperlinkListener(new HyperlinkListener()
	{
		public void hyperlinkUpdate(final HyperlinkEvent e)
		{
			if (e.getEventType() == HyperlinkEvent.EventType.ACTIVATED)
			{
				//System.out.println("HyperLink for ModInfo activated");
				//System.out.println(e.getURL().toString());
				getAppletContext().showDocument(e.getURL(), "MainFrame");
			}
		}
	});
	JGlossaryEditorPane.addHyperlinkListener(new HyperlinkListener()
	{
		public void hyperlinkUpdate(final HyperlinkEvent e)
		{
			if (e.getEventType() == HyperlinkEvent.EventType.ACTIVATED)
			{
				//System.out.println("HyperLink for Glossary activated");
				//System.out.println(e.getURL().toString());
				getAppletContext().showDocument(e.getURL(), "MainFrame");
			}
		}
	});
	JKeywordEditorPane2.addHyperlinkListener(new HyperlinkListener()
	{
		public void hyperlinkUpdate(final HyperlinkEvent e)
		{
			if (e.getEventType() == HyperlinkEvent.EventType.ACTIVATED)
			{
				//System.out.println("HyperLink for Keyword activated");
				//System.out.println(e.getURL().toString());
				getAppletContext().showDocument(e.getURL(), "MainFrame");
			}
		}
	});
	JAboutEditorPane3.addHyperlinkListener(new HyperlinkListener()
	{
		public void hyperlinkUpdate(final HyperlinkEvent e)
		{
			if (e.getEventType() == HyperlinkEvent.EventType.ACTIVATED)
			{
				//System.out.println("HyperLink for About activated");
				System.out.println(e.getURL().toString());
				getAppletContext().showDocument(e.getURL(), "MainFrame");
			}
		}
	});
	// user code end
	getSearchText().addActionListener(EventHandler);
	getSearchButton().addActionListener(EventHandler);
	getModSelectCombo().addActionListener(EventHandler);
	getShowAllButton().addActionListener(EventHandler);
	getJTabbedPane1().addChangeListener(EventHandler);
	getJModLoadButton1().addActionListener(EventHandler);
	getLoadButton().addActionListener(EventHandler);
}
/**
 * Comment
 */
public void jModLoadButton1_ActionPerformed(java.awt.event.ActionEvent actionEvent)
{
	Modules_db modules = storage.getModules();
	Object selected = ModSelectCombo.getSelectedItem();
	//System.out.println(test.toString());
	//figure out which module it is from the Modules_db
	Enumeration mod = modules.getItem_vector().elements();
	if (mod.hasMoreElements())
	{
		while (mod.hasMoreElements())
		{
			//System.out.println("there are elements");
			Modules_item theMod = (Modules_item) mod.nextElement();
			if (selected.toString() == theMod.toString())
			{
				getAppletContext().showDocument(theMod.getIndex(), "MainFrame");
				System.out.println("LoadMod activated");
				System.out.println(theMod.getIndex());
			}
		}
	}
	else
		System.out.println("there be no elements here");
	return;
}
/**
 * Comment
 */
public void jTabbedPane1_StateChanged(javax.swing.event.ChangeEvent stateChangeEvent) {
	if (JTabbedPane1.getSelectedIndex() == 0)
	{
		SearchButton.setText("Search Glossary");
	}
	if (JTabbedPane1.getSelectedIndex() == 1)
	{
		SearchButton.setText("Search Glossary");
	}
	if (JTabbedPane1.getSelectedIndex() == 2)
	{
		SearchButton.setText("Search Keywords");
	}
	if (JTabbedPane1.getSelectedIndex() == 3)
	{
		SearchButton.setText("Search Glossary");
	}
	return;
}
/**
 * Called when a key has been pressed.
 * @param e the received event
 */
public void keyPressed(KeyEvent e) {
	System.out.println("keyPressed");
}
/**
 * Called when a key has been released.
 * @param e the received event
 */
public void keyReleased(KeyEvent e) {
	System.out.println("keyReleased");
}
/**
 * Called when a key has been typed.
 * @param e the received event
 */
public void keyTyped(KeyEvent e) {
	System.out.println("keyTyped");
}
/**
 * Insert the method's description here.
 * Creation date: (04/18/00 12:30:04)
 */
private void loadModCombo()
{
	Modules_db modules = storage.getModules();
	Enumeration mod = modules.getItem_vector().elements();
	if (mod.hasMoreElements())
	{
		while (mod.hasMoreElements())
		{
			//System.out.println("there are elements");
			String line = mod.nextElement().toString();
			ModSelectCombo.addItem(line);
			//System.out.println(line);

		}
	}
}
/**
 * main entrypoint - starts the part when it is run as an application
 * @param args java.lang.String[]
 */
public static void main(java.lang.String[] args) {
	try {
		Frame frame = new java.awt.Frame();
		PMembedable awideAndShallow;
		Class iiCls = Class.forName("wideAndShallow");
		ClassLoader iiClsLoader = iiCls.getClassLoader();
		awideAndShallow = (PMembedable)java.beans.Beans.instantiate(iiClsLoader,"wideAndShallow");
		frame.add("Center", awideAndShallow);
		frame.setSize(awideAndShallow.getSize());
		frame.addWindowListener(new java.awt.event.WindowAdapter() {
			public void windowClosing(java.awt.event.WindowEvent e) {
				System.exit(0);
			};
		});
		frame.setVisible(true);
	} catch (Throwable exception) {
		System.err.println("Exception occurred in main() of javax.swing.JApplet");
		exception.printStackTrace(System.out);
	}
}
/**
 * Comment:  this is activated when a module is selected in the combo box.
//IMPORTANT
//this will load the first item from the JComboBox1_ModList
//automaticaly.  this could be used to load documentation
//at start up
//IMPORTANT
 */
public void modSelectCombo_ActionPerformed(java.awt.event.ActionEvent actionEvent)
{
	Modules_db modules = storage.getModules();
	if (JTabbedPane1.getSelectedIndex() != 0)
	{
		JTabbedPane1.setSelectedIndex(0);
	}
	//get the selected module
	Object selected = ModSelectCombo.getSelectedItem();
	//figure out which module it is from the Modules_db
	Enumeration mod = modules.getItem_vector().elements();
	if (mod.hasMoreElements())
	{
		while (mod.hasMoreElements())
		{
			Modules_item theMod = (Modules_item) mod.nextElement();
			if (selected.toString() == theMod.toString())
			{
				StringReader sr = new StringReader(theMod.getAboutFile());
				//Document doc = JAboutEditorPane3.getDocument();
				try
				{
					JModSelectEditorPane2.read(sr, JModSelectEditorPane2.getDocument()); 
				}
				catch (IOException e)
				{
					context.showStatus("java.io.IOExecption e");
				} 
			}
		}
	}
	else
		System.out.println("there be no elements here");
	return;
}
/**
 * Called when the mouse has been clicked.
 * @param e the received event
 */
public void mouseClicked(MouseEvent e) {
	System.out.println("mouseClicked");
}
/**
 * Called when the mouse has been dragged.
 * @param e the received event
 */
public void mouseDragged(MouseEvent e) {
	System.out.println("mouseDragged");
}
/**
 * Called when the mouse has entered a window.
 * @param e the received event
 */
public void mouseEntered(MouseEvent e) {
	System.out.println("mouseEntered");
}
/**
 * Called when the mouse has exited a window.
 * @param e the received event
 */
public void mouseExited(MouseEvent e) {
	System.out.println("mouseExited");
}
/**
 * Called when the mouse has been moved.
 * @param e the received event
 */
public void mouseMoved(MouseEvent e) {
	System.out.println("mouseMoved");
}
/**
 * Called when a mouse button has been pressed.
 * @param e the received event
 */
public void mousePressed(MouseEvent e) {
	System.out.println("mousePressed");
}
/**
 * Called when a mouse button has been released.
 * @param e the received event
 */
public void mouseReleased(MouseEvent e) {
	System.out.println("mouseReleased");
}
/**
 * Paints the applet.
 * If the applet does not need to be painted (e.g. if it is only a container for other
 * awt components) then this method can be safely removed.
 * 
 * @param g  the specified Graphics window
 * @see #update
 */
public void paint(Graphics g) {
	super.paint(g);

	// insert code to paint the applet here
}
/**
 * Comment:  when the search buton is activated the the results of the search are displayed in
 * the appropriate tab for the data searched on.  The selection of data to search on is based on
 * the active tab.  If the active tab is Keywords then keywords are searched.  In all other 
 * cases glossary words are searched.
 */
public void searchButton_ActionPerformed(java.awt.event.ActionEvent actionEvent)
{
	String key = SearchText.getText();
	if (JTabbedPane1.getSelectedIndex() == 0)
	{
		int tabIndex = JTabbedPane1.indexOfTab("Glossary");
		JTabbedPane1.setSelectedIndex(tabIndex);
	}
	if (JTabbedPane1.getSelectedIndex() == 3)
	{
		int tabIndex = JTabbedPane1.indexOfTab("Glossary");
		JTabbedPane1.setSelectedIndex(tabIndex);
	}
	if (JTabbedPane1.getSelectedIndex() == 1)
	{
		Glossary_db glossaryDB = storage.getGlossaryDB();

		//StringReader sr = new StringReader(glossaryDB.makeResultHtmlString(results));
		try
		{
			Vector results = glossaryDB.search(key);
			StringReader sr = new StringReader(glossaryDB.makeResultHtmlString(results));
			try
			{
				JGlossaryEditorPane.read(sr, JGlossaryEditorPane.getDocument());
			}
			catch (IOException e)
			{
				System.out.println("java.io.IOExecption e");
			}

		}
		catch (java.lang.Error e)
		{
			JGlossaryEditorPane.setText("No entries were found. Sorry.");
			System.out.println("there be no elements here");
		}
	}
	else
	{
		//it is a keyword search
		//to do later

		Keyword_db keywordDB = storage.getKeywordDB();

		//StringReader sr = new StringReader(glossaryDB.makeResultHtmlString(results));
		try
		{
			Vector results = keywordDB.search(key);
			StringReader sr = new StringReader(keywordDB.makeResultHtmlString(results));
			try
			{
				JKeywordEditorPane2.read(sr, JKeywordEditorPane2.getDocument());
			}
			catch (IOException e)
			{
				System.out.println("java.io.IOExecption e");
			}

		}
		catch (java.lang.Error e)
		{
			JGlossaryEditorPane.setText("No entries were found. Sorry.");
			System.out.println("there be no elements here");
		}


		
	}
	return;
}
/**
 * Comment:  This is activated when retrun or enter is hit in the text entry box.
 * it then activates the searchButton_ActionPerformed(actionEvent) and passes it the
 * actionEvent to search on.
 */
public void searchText_ActionPerformed(java.awt.event.ActionEvent actionEvent) {
	searchButton_ActionPerformed(actionEvent);
	return;
}
/**
 * Insert the method's description here.
 * Creation date: (04/05/00 20:58:10)
 * @param newContext java.applet.AppletContext
 */
private void setContext(java.applet.AppletContext newContext) {
	context = newContext;
}
/**
 * Comment:  when the sho all buton is activated the values of the data are displayed in
 * the appropriate tab for the data.  The selection of data to display on is based on
 * the active tab.  If the active tab is Keywords then keywords are displayed.  In all other 
 * cases glossary words are displayed.
 */
public void showAllButton_ActionPerformed(java.awt.event.ActionEvent actionEvent)
{
	if (JTabbedPane1.getSelectedIndex() == 0)
	{
		JTabbedPane1.setSelectedIndex(1);
	}
	if (JTabbedPane1.getSelectedIndex() == 1)
	{
		Glossary_db glossaryDB = storage.getGlossaryDB();
		if (!(glossaryDB.isSorted()))
		{
			context.showStatus("Sorting and loading Glossary Entries");
		}
		else
		{
			context.showStatus("Loading Glossary Entries");
		}
		try
		{
			String html = glossaryDB.makeSortedHtmlString();
			StringReader sr = new StringReader(html);
			try
			{
				JGlossaryEditorPane.read(sr, JGlossaryEditorPane.getDocument());
			}
			catch (IOException e)
			{
				context.showStatus("java.io.IOExecption e");
			}
		}
		catch (NullPointerException en)
		{
			context.showStatus("Failure to create html for display");
		}
	}
	if (JTabbedPane1.getSelectedIndex() == 2)
	{
		Keyword_db keywordDB = storage.getKeywordDB();
		if (!(keywordDB.isSorted()))
		{
			context.showStatus("Sorting and loading Glossary Entries");
		}
		else
		{
			context.showStatus("Loading Glossary Entries");
		}
		try
		{
			String html = keywordDB.makeSortedHtmlString();
			StringReader sr = new StringReader(html);
			try
			{
				JKeywordEditorPane2.read(sr, JKeywordEditorPane2.getDocument());
			}
			catch (IOException e)
			{
				context.showStatus("java.io.IOExecption e");
			}
		}
		catch (NullPointerException en)
		{
			context.showStatus("Failure to create html for display");
		}
	}
	if (JTabbedPane1.getSelectedIndex() == 3)
	{
		JTabbedPane1.setSelectedIndex(1);
	}
	return;
}
/**
 * Insert the method's description here.
 * Creation date: (04/09/00 17:37:53)
 * @param word java.lang.String
 *used from another applet to tell run and search on the glossary DB
 */
public void tellWord(String key)
{   
	Glossary_db glossaryDB = storage.getGlossaryDB();
	if (JTabbedPane1.getSelectedIndex() != 1)
	{
		int tabIndex = JTabbedPane1.indexOfTab("Glossary");
		JTabbedPane1.setSelectedIndex(tabIndex);
	}
	try
	{
		Vector results = glossaryDB.search(key);
		StringReader sr = new StringReader(glossaryDB.makeResultHtmlString(results));
		try
		{
			JGlossaryEditorPane.read(sr, JGlossaryEditorPane.getDocument());
		}
		catch (IOException e)
		{
			System.out.println("java.io.IOExecption e");
		}
		
	}
	catch (java.lang.Error e)
	{
		JGlossaryEditorPane.setText("No entries were found. Sorry.");
		System.out.println("there be no elements here");
	}
}
}
